#!/bin/bash

GUI="ArrayBasedList.kmdr"

. ./functions

Init()
{
    init    
 {   
	/bin/cp -f ArrayBasedList.conf ArrayBasedList.conf.bak
	. ./ArrayBasedList.conf

    echo "LASTROW=\"$LASTROW\""
    echo $LASTROW >LASTROW

    for ((COUNT = 1; COUNT <= $LASTROW; COUNT++))
    do
        ROW=$((COUNT - 1))

        Widget Logins insertRow $ROW 1
        Widget Logins setRowCaption  $ROW $COUNT
        
        Widget Logins setCellText $ROW 0 "${SAVEDUSER[$COUNT]}"
        Widget Logins setCellText $ROW 1 "${SAVEDHOST[$COUNT]}"
        Widget Logins setCellText $ROW 2 "${SAVEDEXEC[$COUNT]}"
        Widget Logins setCellText $ROW 3 "${SAVEDXFLAG[$COUNT]}"
        
	    echo "SAVEDUSER[$COUNT]=\"${SAVEDUSER[$COUNT]}\""
	    echo "SAVEDHOST[$COUNT]=\"${SAVEDHOST[$COUNT]}\""
	    echo "SAVEDEXEC[$COUNT]=\"${SAVEDEXEC[$COUNT]}\""
	    echo "SAVEDXFLAG[$COUNT]=\"${SAVEDXFLAG[$COUNT]}\""
    done

 } >>$LOG 2>>$LOG
}

Destroy()
{
 {   
    rm -f LASTROW
 } >>$LOG 2>>$LOG
 
 destroy
}

# Not in use yet
RunOnConsole()
{
 {   
	COMMAND="$1"

	Widget Console setAssociatedText "$COMMAND"
	Widget Console execute
 } >>$LOG 2>>$LOG
}

SaveAll()
{
 {
    LASTROW=`< LASTROW`
    echo "LASTROW=$LASTROW"
 
    echo "LASTROW=$LASTROW" >ArrayBasedList.conf
     
    for ((NUMBER = 1; NUMBER <= $LASTROW; NUMBER++))
    do
        ROW=$((NUMBER - 1))
    
        SAVEDUSER="`Widget Logins cellText $ROW 0`"
        SAVEDHOST="`Widget Logins cellText $ROW 1`"
        SAVEDEXEC="`Widget Logins cellText $ROW 2`"
        SAVEDXFLAG="`Widget Logins cellText $ROW 3`"
        
	    echo "NUMBER=\"$NUMBER\""
	    echo "ROW=\"$ROW\""
	    echo "SAVEDUSER=\"$SAVEDUSER\""
	    echo "SAVEDHOST=\"$SAVEDHOST\""
	    echo "SAVEDEXEC=\"$SAVEDEXEC\""
	    echo "SAVEDXFLAG=\"$SAVEDXFLAG\""
        
	    echo "SAVEDUSER[$NUMBER]=\"$SAVEDUSER\"" >>ArrayBasedList.conf
	    echo "SAVEDHOST[$NUMBER]=\"$SAVEDHOST\"" >>ArrayBasedList.conf
	    echo "SAVEDEXEC[$NUMBER]=\"$SAVEDEXEC\"" >>ArrayBasedList.conf
	    echo "SAVEDXFLAG[$NUMBER]=\"$SAVEDXFLAG\"" >>ArrayBasedList.conf
    done
    
 } >>$LOG 2>>$LOG
}

SendKey()
{
 {   
    CURRENTROW=`Widget Logins currentRow`

    USER="`Widget Logins cellText $CURRENTROW 0`"
    HOST="`Widget Logins cellText $CURRENTROW 1`"
    
    echo "USER=\"$USER\""
    echo "HOST=\"$HOST\""
    
    if [ ! -e "~/.ssh/id_dsa.pub" ]
    then
   	    xterm -hold -e "ssh-keygen -t dsa"
    fi

   	xterm -hold -e "scp ~/.ssh/id_dsa.pub $USER@$HOST:~/.ssh/authorized_keys2"

 } >>$LOG 2>>$LOG
}

TableLogon()
{
 {
    CURRENT_ROW=$1
    echo "CURRENT_ROW=$CURRENT_ROW"
    
    echo "From widget `Widget Logins currentRow`"
    
 } >>$LOG 2>>$LOG
}

Add()
{
 {
    echo "Add"
    LASTROW=`< LASTROW`
    echo "LASTROW=$LASTROW"

    Widget Logins insertRow $LASTROW 1
    Widget Logins setRowCaption $LASTROW $((LASTROW + 1))
    
    echo $((LASTROW + 1)) >LASTROW
    
 } >>$LOG 2>>$LOG
}

Delete()
{
 {   
    echo "Delete"
    
    LASTROW=`< LASTROW`
    echo "LASTROW=$LASTROW"
    
    CURRENTROW=`Widget Logins currentRow`
    USER="`Widget Logins cellText $CURRENTROW 0`"
    HOST="`Widget Logins cellText $CURRENTROW 1`"
    
    echo "CURRENTROW=\"$CURRENTROW\""
    echo "USER=\"$USER\""
    echo "HOST=\"$HOST\""
    
    if [ -n "$CURRENTROW" ] && kdialog --yesno "Remove $USER@$HOST, are you sure?"
    then
        Widget Logins removeRow $CURRENTROW 1
    
        echo $((LASTROW - 1)) >LASTROW
    fi
   
 } >>$LOG 2>>$LOG
}

Logon()
{
 {   
    CURRENTROW=`Widget Logins currentRow`
    
    echo "CURRENTROW=\"$CURRENTROW\""

    USER="`Widget Logins cellText $CURRENTROW 0`"
    HOST="`Widget Logins cellText $CURRENTROW 1`"
    EXEC="`Widget Logins cellText $CURRENTROW 2`"
    WITHX="`Widget Logins cellText $CURRENTROW 3`"
	
    echo "USER=\"$USER\""
    echo "HOST=\"$HOST\""
    echo "EXEC=\"$EXEC\""
    echo "WITHX=\"$WITHX\""

    SaveAll
	
	[ -n "$WITHX" ] && PARAMETER="-X"

   	xterm +sb -vb -hold -title "$USER@$HOST" -e "ssh -o ConnectTimeout=5 $USER@$HOST $PARAMETER $EXEC" &
    quit

 } >>$LOG 2>>$LOG
}

# This is a help text which will be output if this is run without any parameters
HELP="USE: $0 <user> <host> 1=With X,0=No X <program>
or run GUI by:
$0 --GUI"

main Logon "$@"
