#!/bin/bash

Search()
{
	SEARCHTEXT="$1"
	
	dcop $DIALOGID KommanderIf clear SearchResults
	
	rm -f result
	xterm +sb -vb -e 'sudo aptitude search "*'"$SEARCHTEXT"'*" |tee result'
	
	for RESULT in `awk  '/'"$SEARCHTEXT"'/ {sub (/[. \t].*$/, "", $1); print $1}' result`
	do
		dcop $DIALOGID KommanderIf insertItem SearchResults "$RESULT" 0
	done
}

SetPackage()
{
	PACKAGE="$1"
	
	dcop $DIALOGID KommanderIf setText PackageBox "$PACKAGE" &
}

Info()
{
	PACKAGE=$1
	
	rm -f result
	xterm +sb -vb -e 'sudo yum info '"$PACKAGE"' |tee result'
	
	sed -i  '0,/.*Packages$/d' result
	
	kdialog --textbox result 500 350 &
}

Listboxes()
{
	PACKAGE=$1
	
	xterm +sb -vb -e 'sudo aptitude install -y '"$PACKAGE"' |tee result'
	
	kdialog --textbox result 750 1000
}

# Use this as the main entry point
if [ -z "$DIALOGID" ]
then
    if [ "$1" == "--GUI" ]
    then
    	kmdr-executor Listboxes.kmdr
    else
        if [ $# -lt 1 ]
        then
            echo "USE: $0 <parameter>"
            echo "or run GUI by:"
            echo "$0 --GUI"
            exit
        fi
    
        Button1 $1
    fi
fi
